import 'package:flutter/material.dart';

import './rpx.dart';
import './colors.dart';

class AtDivider extends StatelessWidget with Rpx {
  final Axis direction;
  final double width;
  final Color color;
  final EdgeInsetsGeometry margin;

  AtDivider({
    Key key,
    this.direction = Axis.horizontal,
    this.width,
    this.color = AtColors.borderColor,
    this.margin,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    rpxInit(context);

    return Container(
      color: color,
      width: direction == Axis.vertical ? rpx(1) : width != null ? width : null,
      height: direction == Axis.horizontal ? rpx(1) : width != null ? width : null,
      margin: margin,
    );
  }
}
